let res = [];

/**
 *
 * @param {HTMLDivElement} editor
 */
export function toJSON(editor) {
  // console.log(editor.innerHTML);
  res = [];
  for (const e of [...editor.childNodes]) {
    toSection(e);
  }
  const newRes = [];
  for (let s of res) {
    let newS = [];
    for (const b of s) {
      const toB = toBlock(b);
      if (toB) newS.push(toB);
    }
    if (newS.length === 0) {
      // 空行特殊处理
      newS = [{ type: "text", value: " ", param: null }];
    }
    newRes.push({ blocks: newS });
  }
  res = { sections: newRes };
  // console.log(res);
  // console.log(JSON.stringify(res));
  // console.log(JSON.stringify(res, null, 2));
  return JSON.stringify(res, null, 2);
}

/**
 *
 * @param {Node} e
 */
function toSection(e) {
  if (e.nodeType == Node.ELEMENT_NODE && e.nodeName === "DIV") {
    res.push(e.childNodes);
  } else if (e.nodeType == Node.TEXT_NODE) {
    res.push([e]);
  } else {
    console.log("toSection: 非div, 非TEXT", e);
  }
}

/**
 *
 * @param {Node} e
 */
function toBlock(e) {
  let block = {};
  if (e.nodeType === Node.TEXT_NODE) {
    block.type = "text";
    block.value = e.textContent;
    block.param = null;
    // } else if (e.nodeType == Node.ELEMENT_NODE && e.nodeName === "SPAN") {
    //   block.type = "text";
    //   block.value = e.textContent;
    //   block.param = {};
  } else if (e.nodeType == Node.ELEMENT_NODE && e.nodeName === "U") {
    block.type = "text";
    block.value = e.textContent;
    block.param = { underline: true };
  } else if (e.nodeType == Node.ELEMENT_NODE && e.nodeName === "B") {
    block.type = "text";
    block.value = e.textContent;
    block.param = { bold: true };
  } else if (e.nodeType == Node.ELEMENT_NODE && e.nodeName === "I") {
    block.type = "text";
    block.value = e.textContent;
    block.param = { italic: true };
  } else if (e.nodeType == Node.ELEMENT_NODE && e.nodeName === "IMG") {
    block.type = "image";
    block.value = e.src;
    block.param = { width: e.width, height: e.height };
  } else if (e.nodeType == Node.ELEMENT_NODE && e.nodeName === "BR") {
    block.type = "text";
    block.value = "";
    block.param = null;
  } else {
    console.log("toBlock: 非法", e);
  }

  if (block.type === "text" && block.value === "") {
    block = null; // 返回null的block，从json中剔除
  }
  return block;
}
